<template>
  <dlg :loading="ShowSpinner">
    <template v-slot:header>
      <div class="pull-left"><h4 class="modal-title">Analyzers &raquo; Rates &raquo; Edit</h4></div>
      <div class="pull-right input-group input-group-xs" style="width:200px" v-if="Rate.Template==null">
        <input type="text" class="form-control" placeholder="Filter..." v-model="Filter">
        <span class="input-group-btn">
          <button type="button" class="btn btn-default btn-xs" @click="$emit('endEdit', index, Rate)"><img :src="require('Imgs/arrow_undo.png')" alt="Back"></button>
        </span>
      </div>
      <div class="pull-right btn-group" v-if="Rate.Template!=null">
        <button type="button" class="btn btn-default btn-xs" :class="{ active: View=='Main' }" @click="View='Main'">Main</button>
        <button type="button" class="btn btn-default btn-xs" :class="{ active: View=='Periods' }" @click="View='Periods'">Periods</button>
        <button type="button" class="btn btn-default btn-xs" :class="{ active: View=='Concepts' }" @click="View='Concepts'">Concepts</button>
        <button type="button" class="btn btn-default btn-xs" :class="{ active: View=='Cycles' }" @click="View='Cycles'">Cycles</button>
        <button type="button" class="btn btn-default btn-xs" @click="$emit('endEdit', index, Rate)"><img :src="require('Imgs/arrow_undo.png')" alt="Back"></button>
      </div>
    </template>
    <div class="alert alert-danger text-center" style="margin-bottom: 5px; padding: 5px" v-if="Error!=null">{{ Error }}</div>
    <div class="row" v-if="Rate.Template==null">
      <spinner v-if="ShowSpinner"></spinner>
      <vuetable ref="table" :fields="Columns" :api-mode="false" :data="Tariffs" class="table small table-striped">
        <template slot="actions" slot-scope="props">
          <div class="btn-group" >
            <button class="btn btn-xs btn-default" @click="LoadTariff(props.rowData)">Load</button>
          </div>
        </template>
      </vuetable>
    </div>
    <div v-if="Rate.Template!=null">
      <div class="row" v-if="View=='Main'">
        <div class="alert alert-success text-center" style="margin-bottom: 5px; padding: 5px" v-if="Error==null">
          {{ Rate.Template.Description }}<br>
          <span style="font-size: 80%">Tariff contains {{ Rate.Template.Seasons.length }}  seasons, a total of {{ Rate.Template.Periods.length }}  day periods and {{ Rate.Template.Holidays.length }} holidays<br>
          Rate contains {{ Rate.Config.Taxs.length }}  concepts and {{ Rate.Config.Billing.length + 1 }} bills</span>
        </div>
        <div class="col-xs-12 col-sm-6">
          <label class="control-label">From</label>
          <date-picker :options="{ format: 'DD/MM/YYYY', viewMode: 'months', timeZone: analyzer.TimeZone }" :big="true" v-model="Rate.StartDate"></date-picker>
        </div>
        <div class="col-xs-12 col-sm-6">
          <label class="control-label">To</label>
          <date-picker :options="{ format: 'DD/MM/YYYY', viewMode: 'months', timeZone: analyzer.TimeZone }" :big="true" v-model="Rate.EndDate"></date-picker>
        </div>
        <div class="col-xs-12" style="margin-top: 5px">
          <button type="button" class="btn btn-default btn-xs btn-danger" style="width:100%" @click="LoadTariffs()">Change tariff template</button>
        </div>
      </div>
      <div class="row periods" v-if="View=='Periods'">
        <div class="col-xs-12">
          <table>
            <tr>
              <td></td>
              <td><strong>Contracted power</strong></td>
              <td><strong>Power costs</strong></td>
              <td><strong>Energy costs</strong></td>
            </tr>
            <tr v-for="(period, idx) in Rate.Config.Periods" :key="idx">
              <td><strong>P{{idx + 1}}</strong></td>
              <td>
                <input-spin :max="100000" :min="0" prepend="kW" :decimals="6" :increment="1" :value="period.Contracted_Power/1000" @input="Rate.Config.Periods[idx].Contracted_Power=$event*1000; Rate = Object.assign({}, Rate)"></input-spin>
              </td>
              <td>
                <input-spin :max="100000" :min="0" prepend="€/kW/day" :decimals="6" :increment="1" :value="period.Power_Cost*1000" @input="Rate.Config.Periods[idx].Power_Cost=$event/1000; Rate = Object.assign({}, Rate)"></input-spin>
              </td>
              <td>
                <input-spin :max="100000" :min="0" prepend="€/kWh" :decimals="6" :increment="1" :value="period.Energy_Cost*1000" @input="Rate.Config.Periods[idx].Energy_Cost=$event/1000; Rate = Object.assign({}, Rate)"></input-spin>
              </td>
            </tr>
          </table>
        </div>
      </div>
      <div class="row" v-if="View=='Concepts'">
        <div class="col-xs-12">
          <table>
            <tr>
              <td><strong>Concept</strong></td>
              <td><strong>Type</strong></td>
              <td class="text-right"><strong>Value</strong></td>
            </tr>
            <tr v-for="(tax, idx) in Rate.Config.Taxs" :key="idx">
              <td>
                <div class="input-group input-group-xs">
                  <span class="input-group-btn"><button class="btn btn-default" type="button" @click="Rate.Config.Taxs.splice(idx, 1)"><img :src="require('Imgs/cross.png')"></button></span>
                  <input type="text" class="form-control" v-model="tax.Name">
                </div>
              </td>
              <td>
                <option-picker :options="[ {name: 'Total', value: 'PERCENT_TOTAL'}, {name: 'Energy', value: 'PERCENT_ENERGY'}, {name: 'Power', value: 'PERCENT_POWER'}, {name: 'Energy+Power', value: 'PERCENT_ENERGY_POWER'}, {name: 'Fixed', value: 'FIXED_QUANTITY'} ]" v-model="tax.Type"></option-picker>
              </td>
              <td>
                <input-spin :max="100000" :min="-100000" :prepend="(tax.Type == 'FIXED_QUANTITY') ? '€/Bill cycle' : '%'" :decimals="6" :increment="1" :value="tax.Value" @input="Rate.Config.Taxs[idx].Value=$event; Rate = Object.assign({}, Rate)"></input-spin>
              </td>
            </tr>
            <tr>
              <td colspan="3">
                <button type="button" class="btn btn-default btn-xs" style="width:100%" @click="Rate.Config.Taxs.push({Name: 'Unnamed tax', Type: 'PERCENT_TOTAL', Value: 0.0})"><img :src="require('Imgs/plus.png')"> New concept</button>
              </td>
            </tr>
          </table>
        </div>
      </div>
      <div class="row" v-if="View=='Cycles'">
        <div class="col-xs-12">
          <table>
            <tr>
              <td style="min-width: 120px"><strong>From</strong></td>
              <td style="width: 100%"><strong>To</strong></td>
              <td class="text-right" style="min-width: 120px"><strong>Duration</strong></td>
            </tr>
            <tr v-for="(date, idx) in Rate.Config.Billing.concat([Rate.EndDate])" :key="idx">
              <td>
                <div class="input-group input-group-xs">
                  <span class="input-group-btn" v-if="idx!=Rate.Config.Billing.length">
                    <button class="btn btn-default" type="button" @click="Rate.Config.Billing.splice(idx, 1)"><img :src="require('Imgs/cross.png')"></button>
                  </span>
                  <input type="text" class="form-control" disabled="" :value="FormatDate(StartDate(idx))">
                </div>
              </td>
              <td>
                <date-picker :big="false" :options="{ format: 'DD/MM/YYYY', viewMode: 'months', timeZone: analyzer.TimeZone }" :value="EndDate(idx)" @input="SetBillPeriods(idx, $event)" :disabled="idx==Rate.Config.Billing.length"></date-picker>
              </td>
              <td class="text-right">
                <div class="input-group input-group-xs">
                  <input type="text" class="form-control text-right" disabled="" :value="CalcDays(idx)">
                  <span class="input-group-addon">Days</span>
                </div>
              </td>
            </tr>
            <tr>
              <td><button type="button" class="btn btn-default btn-xs" style="width:100%" @click="AddBillDay"><img :src="require('Imgs/plus.png')"> New bill</button></td>
              <td style="display: flex">
                <option-picker class="flex-item" :options="BillDayNames.map((val, idx) => { return { name: val, value: idx }; })" v-model="Day"></option-picker>&nbsp;
                <option-picker class="flex-item" :options="PeriodNames.map((val, idx) => { return { name: val, value: idx }; })" v-model="Period"></option-picker>&nbsp;
                <button type="button" class="btn btn-default btn-xs flex-item" @click="BuildPeriods" data-toggle="tooltip" title="Create or replace bill days according to selections"><img :src="require('Imgs/wand.png')"></button>
              </td>
              <td></td>
            </tr>
          </table>
        </div>
      </div>
    </div>
  </dlg>
</template>

<script>
  import Vuetable from 'vuetable-2';
  import moment from 'moment';
  import * as oZm from 'JS/openZmeter.js';
  export default {
    props: { analyzer: Object, index: Number },
    data() {
      return { View: 'Main', Rate: null, Day: 0, Period: 0, ShowSpinner: false, Filter: '', Tariffs: null,
        PeriodNames: ['Each month', 'Each two month', 'Each three month'],
        BillDayNames: ['1st', '2nd', '3rd', '4th', '5th', '6th', '7th', '8th', '9th', '10th', '11th', '12th', '13th', '14th', '15th', '16th', '17th', '18th', '19th', '20th', '21th', '22th', '23th', '24th', '25th', '26th', '27th', '28th'],
        Columns: [
          { name: 'Name', title: 'Name' },
          { name: 'StartDate', title: 'Start date' },
          { name: 'EndDate', title: 'End date' },
          { name: '__slot:actions', title: '' }
        ]
      };
    },
    created: function() {
      this.Rate = Object.assign({}, this.analyzer.Rates[this.index]);
      if(this.Rate.Template == null) this.LoadTariffs();
    },
    computed: {
      Error: function() {
        if(this.Rate.Template == null) return 'Select a base tariff from table before continue';
        if(this.Rate.StartDate < this.Rate.Template.Seasons[0].StartDate) return 'Date ranges is outside selected tariff ranges';
        if(this.Rate.EndDate > this.Rate.Template.Seasons.slice(-1)[0].EndDate) return 'Date ranges is outside selected tariff ranges';
        return null;
      },
    },
    methods: {
      FormatDate: function(val) {
        return moment(val).tz(this.analyzer.TimeZone).format('DD/MM/YYYY');
      },
      LoadTariffs: function() {
        this.ShowSpinner = true;
        this.Rate.Template = null;
        this.$http.post('getTariffs', {}).then(
          (result) => {
            this.Tariffs = result.body;
            for(var n in this.Tariffs) {
              this.Tariffs[n].StartDate = moment.tz(this.Tariffs[n].StartDate, this.Tariffs[n].TimeZone).format('DD/MM/YYYY');
              this.Tariffs[n].EndDate   = moment.tz(this.Tariffs[n].EndDate,   this.Tariffs[n].TimeZone).format('DD/MM/YYYY');
            }
            this.ShowSpinner = false;
          },
          (fail) => { }
        );
      },
      LoadTariff: function(tariff) {
        this.ShowSpinner = true;
        this.$http.post('getTariff', { TariffID: tariff.TariffID }).then(
          (result) => {
            this.Rate.Template = result.body.Template;
            this.Rate.Name = result.body.Name;
            this.Rate.StartDate = result.body.StartDate;
            this.Rate.EndDate = result.body.EndDate;
            this.Rate.Config.Periods.length = this.Rate.Template.Periods.length;
            for(var n = 0; n < this.Rate.Template.Periods.length; n++) this.Rate.Config.Periods[n] = Object.assign({ Contracted_Power: 0.0, Energy_Cost: 0.0, Power_Cost: 0.0 }, this.Rate.Config.Periods[n]);
            this.ShowSpinner = false;
          },
          (fail) => { }
        );
      },






//      Show: function(analyzer, tariffs, rate) {
//        this.Analyzer = analyzer;
//        this.Tariffs = tariffs;
//        for(var n = 0; n < this.Tariffs.length; n++) {
//          this.Tariffs[n].id = this.Tariffs[n].TariffID;
//          this.Tariffs[n].name = this.Tariffs[n].Name;
//          this.Tariffs[n].description = 'From ' + moment.tz(this.Tariffs[n].StartDate, this.analyzer.TimeZone).format('DD/MM/YYYY') + ' to ' + moment.tz(this.Tariffs[n].EndDate, this.analyzer.TimeZone).format('DD/MM/YYYY');
//        }
//        this.Initial = rate;
//        this.View = 'Main';
//        if(rate === null) {
//          this.Rate = this.EmptyRate;
//        } else {
//          this.Rate = Object.assign({}, rate);
//        }
//        this.$refs.Dialog.Show();
//        this.$nextTick(() => {
//          if(this.Rate.RateID !== undefined) {
//            this.Tariffs.unshift({ id: 'CURRENT', name: '(*) ' + this.Rate.Name, description: 'From ' + moment.tz(this.Rate.StartDate, this.analyzer.TimeZone).format('DD/MM/YYYY') + ' to ' + moment.tz(this.Rate.EndDate, this.analyzer.TimeZone).format('DD/MM/YYYY')});
//          } else {
//            $(this.$refs.Base).attr('data-id', '');
//            $(this.$refs.Base).val('');
//            this.$refs.StartDate.Disable();
//            this.$refs.EndDate.Disable();
//          }
//          this.SetTariffs();
//        });
//      },
//      Round6: function(val) {
//        return oZm.RoundPlain(val, 6);
//      },

      SetBillPeriods: function(idx, val) {
        var Date = moment(val).tz(this.analyzer.TimeZone).endOf('day').valueOf();
        if(this.Rate.Config.Billing[idx] == Date) return;
        this.Rate.Config.Billing[idx] = Date;
        this.Rate.Config.Billing = this.Rate.Config.Billing.sort();
      },
      StartDate: function(idx) {
        if(idx == 0)
          return moment.tz(this.Rate.StartDate, this.analyzer.TimeZone).valueOf();
        else if((idx > 0) && (idx <= this.Rate.Config.Billing.length))
          return moment.tz(this.Rate.Config.Billing[idx - 1] + 1, this.analyzer.TimeZone).valueOf();
      },
      EndDate: function(idx) {
        if((idx >= 0) && (idx < this.Rate.Config.Billing.length))
          return moment.tz(this.Rate.Config.Billing[idx], this.analyzer.TimeZone).valueOf();
        else
          return moment.tz(this.Rate.EndDate, this.analyzer.TimeZone).valueOf();
      },
      CalcDays: function(idx) {
        var To = moment(this.EndDate(idx)).add(1, 'ms');
        var From = moment(this.StartDate(idx));
        return To.diff(From, 'days');
      },
      Save: function() {
        this.ShowSpinner = true;
        this.$http.post((this.Rate.RateID == null) ? 'addRate' : 'setRate', Object.assign({ Analyzer: this.analyzer.Analyzer }, this.Rate)).then(
          (result) => { this.$emit('close', true); },
          (fail) => {
            this.ShowSpinner = false;
            this.Error = 'Failed to save rate to analyzer!';
            setTimeout(() => { this.Error = null; }, 1000);
          }
        );
      },
//      SetStartDate: function(date) {
//        this.Rate.StartDate = date.startOf('day').valueOf();
//        this.Validate();
//      },
//      SetEndDate: function(date) {
//        this.Rate.EndDate = date.endOf('day').valueOf();
//        this.Validate();
//      },
//      Back: function() {
//        this.$refs.Dialog.Close();
//        this.$parent.$refs.Rates.Show(this.analyzer);
//      },
//      PeriodItemChanged: function(value, type, idx) {
//        var Value = parseFloat(value.target.value);
//        if(isNaN(Value) === true) Value = 0.0;
//        if(type === 'Contracted_Power')
//          Value = Value * 1000;
//        else
//          Value = Value / 1000;
//        this.Rate.Config.Periods[idx][type] = Value;
//        this.Rate = Object.assign({}, this.Rate);
//      },
//      ValueConceptChanged: function(value, idx) {
//        var Value = parseFloat(value.target.value);
//        if(isNaN(Value) === true) Value = 0.0;
//        this.Rate.Config.Taxs[idx].Value = Value;
        //this.Rate = Object.assign({}, this.Tariff);
//      },
      AddBillDay: function() {
        this.Rate.Config.Billing.push(this.Rate.EndDate);
      },
      BuildPeriods: function() {
        this.$set(this.Rate.Config, 'Billing', []);
        var Date = moment.tz(this.Rate.StartDate, this.analyzer.TimeZone);
        while(true) {
          Date = Date.add(this.Period + 1, 'M').date(this.Day + 1);
          if(Date.valueOf() >= this.Rate.EndDate) break;
          this.Rate.Config.Billing.push(Date.startOf('day').valueOf() - 1);
        }
      },
//      FillPeriods: function() {
//        this.Rate.Config.Periods.length = this.Rate.Template.Periods.length;
//        for(var n = 0; n < this.Rate.Template.Periods.length; n++) this.Rate.Config.Periods[n] = Object.assign({ Contracted_Power: 0.0, Energy_Cost: 0.0, Power_Cost: 0.0 }, this.Rate.Config.Periods[n]);
//      },
//      SelectBase: function(e, keywork) {
//        this.$refs.StartDate.Enable();
//        this.$refs.EndDate.Enable();
//        if(keywork.id === 'CURRENT') {
//          this.LoadCurrent();
//          this.Validate();
//        } else {
//          this.ShowSpinner = true;
//          $.ajax({ url: "getTariff", timeout: 20000, type: "POST", dataType: "json", contentType: 'application/json', data: JSON.stringify({ TariffID: keywork.id }),
//            success: function(result) {
//              this.Rate.Template = result.Template;
//              this.Rate.Name = result.Name;
//              this.FillPeriods();
//              this.Validate();
//              this.ShowSpinner = false;
//            }.bind(this)
//          });
//        }
//      },
//      DeselectBase: function(e) {
//        this.$refs.StartDate.Disable();
//        this.$refs.EndDate.Disable();
//        this.Error = 'Select a base tariff from list';
//      }
    },
//    beforeDestroy: function() {
//      $(this.$refs.Base).off('onSetSelectValue', this.SelectBase.bind(this));
//      $(this.$refs.Base).off('onUnsetSelectValue', this.DeselectBase.bind(this));
//      $(this.$refs.Base).bsSuggest("destroy");
//    },
    components: { Vuetable }
  }
</script>

<style scoped>
  .table >>> th:nth-child(2), .table >>> th:nth-child(3)  {
    width: 100px;
    text-align: center;
  }
  .table >>> td:nth-child(2), .table >>> td:nth-child(3) {
    text-align: center;
  }
  .table >>> th:nth-child(4) {
    width: 54px;
  }
  .table >>> td:nth-child(4) {
    text-align: right;
  }




  .dropdown-menu >>> .jhover {
    background: #337ab7;
  }
  .dropdown-menu >>> .table {
    margin: 4px 0px 0px 0px !important;
  }
  .dropdown-menu >>> td {
    border: none;
  }
  table, .input-group {
    width: 100%;
  }
  table tr td {
    padding: 1px 3px;
  }
  .periods input, .periods td {
    text-align: right;
  }
</style>